# Copyright (C) 2016-2022, Stefan Kanthak <stefan.kanthak@nexgo.de>

# * The software is provided "as is" without any warranty, neither express
#   nor implied.
# * In no event will the author be held liable for any damage(s) arising
#   from the use of the software.
# * Redistribution of the software is allowed only in unmodified form.
# * Permission is granted to use the software solely for personal private
#   and non-commercial purposes.
# * An individuals use of the software in his or her capacity or function
#   as an agent, (independent) contractor, employee, member or officer of
#   a business, corporation or organization (commercial or non-commercial)
#   does not qualify as personal private and non-commercial purpose.
# * Without written approval from the author the software must not be used
#   for a business, for commercial, corporate, governmental, military or
#   organizational purposes of any kind, or in a commercial, corporate,
#   governmental, military or organizational environment of any kind.

.SUFFIXES:

fubar: FUBAR.DLL FUBAR.EXE FUBAR.MAK
	Call <<FUBAR.CMD
Rem Copyright (C) 2016-2022, Stefan Kanthak <stefan.kanthak@nexgo.de>

Title Case 6
FUBAR.EXE
Echo %ERRORLEVEL%

Title Case 5
"%SystemRoot%\System32\CACLS.EXE" FUBAR.DLL /E /D "%USERNAME%"
FUBAR.EXE
Echo %ERRORLEVEL%

Title Case 4
Erase FUBAR.DLL
FUBAR.EXE
Echo %ERRORLEVEL%

Title Case 3
Copy "%SystemRoot%\System32\NTDLL.DLL" FUBAR.DLL
FUBAR.EXE
Echo %ERRORLEVEL%

Title Case 2
Copy /Y FUBAR.EXE FUBAR.DLL
FUBAR.EXE
Echo %ERRORLEVEL%

Title Case 1
Copy /Y "%SystemRoot%\System32\COMMAND.COM" FUBAR.DLL
FUBAR.EXE
Echo %ERRORLEVEL%

Title Case 0
Copy /Y NUL: FUBAR.DLL
FUBAR.EXE
Echo %ERRORLEVEL%
<<KEEP

clobber: clean
	Erase FUBAR.CMD FUBAR.DLL FUBAR.EXE

clean:
	Erase FUBAR.EXP FUBAR.LIB FUBAR.OBJ

FUBAR.DLL FUBAR.LIB: FUBAR.MAK
	CL.EXE /Brepro /c /DCONSOLE /FoFUBAR.OBJ /GA /GF /Gw /Gy /Gz /nologo /O2 /Tc<< /W4 /wd4100 /we4013 /Zl
// Copyright (C) 2016-2022, Stefan Kanthak <stefan.kanthak@nexgo.de>

#define STRICT
#define WIN32_LEAN_AND_MEAN

#include <windows.h>

__declspec(dllexport)
const	CHAR	FUBAR[] = "Fucked up beyond all recognition\b\b\b\b\b\b\b\b\b\b\b\b\b\b\bmessage identifier 0x8020000B\n";

const	LPCSTR	szReason[4] = {"DLL_PROCESS_DETACH\n",
		               "DLL_PROCESS_ATTACH\n",
		               "DLL_THREAD_ATTACH\n",
		               "DLL_THREAD_DETACH\n"};

BOOL	WINAPI	_DllMainCRTStartup(HANDLE hModule, DWORD dwReason, LPVOID lpReserved)
{
#ifdef CONSOLE
	DWORD	dwConsole;

	WriteConsoleA(GetStdHandle(STD_ERROR_HANDLE), szReason[dwReason], strlen(szReason[dwReason]), &dwConsole, NULL);
#else
	OutputDebugStringA(szReason[dwReason]);
#endif
	return FALSE;
}
<<NOKEEP
	LINK.EXE /LINK /ALLOWBIND:NO /BREPRO /DEFAULTLIB:KERNEL32.LIB /DLL /DYNAMICBASE /ENTRY:_DllMainCRTStartup /EXPORT:FUBAR,DATA /IMPLIB:FUBAR.LIB /LARGEADDRESSAWARE /NOCOFFGRPINFO /NOLOGO /NXCOMPAT /OPT:REF /OSVERSION:5.1 /OUT:FUBAR.DLL /RELEASE /SUBSYSTEM:CONSOLE /SWAPRUN:CD,NET /TEST /VERSION:0.815 FUBAR.OBJ

FUBAR.EXE: FUBAR.MAK
	CL.EXE /Brepro /c /DCONSOLE /FoFUBAR.OBJ /GA /GF /Gw /Gy /Gz /nologo /O2 /Tc<< /W4 /we4013 /Zl
// Copyright (C) 2016-2022, Stefan Kanthak <stefan.kanthak@nexgo.de>

#define STRICT
#define WIN32_LEAN_AND_MEAN

#include <windows.h>

__declspec(dllimport)
extern	const	CHAR	FUBAR[];

__declspec(noreturn)
VOID	WINAPI	mainCRTStartup(VOID)
{
#ifdef CONSOLE
	DWORD	dwConsole;

	WriteConsoleA(GetStdHandle(STD_ERROR_HANDLE), FUBAR, strlen(FUBAR), &dwConsole, NULL);
#else
	OutputDebugStringA(FUBAR);
#endif
	ExitProcess(GetLastError());
}
<<NOKEEP
	LINK.EXE /LINK /BREPRO /DEFAULTLIB:KERNEL32.LIB /DYNAMICBASE /ENTRY:mainCRTStartup /LARGEADDRESSAWARE /NOCOFFGRPINFO /NOLOGO /NXCOMPAT /OPT:REF /OSVERSION:5.1 /OUT:FUBAR.EXE /RELEASE /SUBSYSTEM:CONSOLE /SWAPRUN:CD,NET /TEST /VERSION:0.815 FUBAR.OBJ FUBAR.LIB
